/**
 * Author: S. Smith
 * Revised: March 17, 2009
 * 
 * Description: Testing PointT Class
 */

import org.junit.*;
import static org.junit.Assert.*;

public class TestPointT
{
   private static double ADMISS_ERR_CONSTRUCTOR = 0;
   private static double ADMISS_ERR_DIST = 1e-20;

   @Test
   public void testConstructorForx()
   {
     assertEquals(23, new PointT(23, 38).xcoord(), ADMISS_ERR_CONSTRUCTOR);
   }

   @Test
   public void testConstructorFory()
   {
     assertEquals(38, new PointT(23, 38).ycoord(), ADMISS_ERR_CONSTRUCTOR);
   }

   @Test
   public void testDist1()
   {
     double x = 2.0;
     double y = 2.0;
     PointT p = new PointT(x, y);
     assertEquals(Math.sqrt(x*x + y*y), p.dist(new PointT(0, 0)), ADMISS_ERR_DIST);
   }

   @Test
   public void testDist2()
   {
     double x = 10.0;
     double y = -567.9;
     PointT p = new PointT(x, y);
     assertEquals(Math.sqrt(x*x + y*y), p.dist(new PointT(0, 0)), ADMISS_ERR_DIST);
   }

   @Test
   public void testDistZero()
   {
     double x = 2.0;
     double y = 2.0;     
     PointT p = new PointT(x, y);
     assertEquals(0, p.dist(p), ADMISS_ERR_DIST);
   }

   @Test
   public void testEqual()
   {
     double x = 0.0;
     double y = 0.0;     
     PointT p1 = new PointT(x, y);
     PointT p2 = new PointT(x + PointT.TOLERANCE, y + PointT.TOLERANCE);
     assertEquals(true, p1.equal(p1));
   }

}
